local BaikCore = LibStub("AceAddon-3.0"):GetAddon("BaikCore")
local BaikActionbar = BaikCore.BaikActionbar
local CombatSafe = BaikCore.CombatSafe
local Database = BaikCore.Database
local Log = BaikCore.Log
local Option = BaikCore.Option
local Visibility = BaikCore.Visibility

-- Add Module (Add prefix to avoid collision)
local MicroButton = BaikActionbar:NewModule("MicroButton")

-- Constants
local OPTION_NAME = "micro_style"
local DB_PREFIX = "action_micro"

local VISIBILITY = {
    CharacterMicroButton,
    SpellbookMicroButton,
    TalentMicroButton,
    AchievementMicroButton,
    QuestLogMicroButton,
    GuildMicroButton,
    LFDMicroButton,
    CollectionsMicroButton,
    EJMicroButton,
    StoreMicroButton,
    MainMenuMicroButton,
}

-- Private Methods
local function SetVisibility()
    Visibility:SetupFrameAllAlpha(DB_PREFIX, VISIBILITY)
end

local function GetOpts()
    return {
        name = "MicroButton",
        type = "group",
        args = {
            vis = Visibility:GetOpts(DB_PREFIX, SetVisibility)
        }
    }
end

-- Ace3 Callbacks
function MicroButton:OnInitialize()
    Log:v("MicroButton_OnInitialize")
    Visibility:InitDb(DB_PREFIX)
    Option:AddOption(BaikActionbar.OPTION_NAME, OPTION_NAME, GetOpts())
end

function MicroButton:OnEnable()
    Log:v("MicroButton_OnEnable")
end

function MicroButton:OnDisable()
    Log:v("MicroButton_OnDisable")
end
