local BaikCore = LibStub("AceAddon-3.0"):GetAddon("BaikCore")
local BaikActionbar = BaikCore.BaikActionbar
local Database = BaikCore.Database
local Log = BaikCore.Log
local Option = BaikCore.Option

-- Add Module
local TrackingBar = BaikActionbar:NewModule("TrackingBar")

-- Constants
local OPTION_NAME = "action_tracking_style"
local TRACKING_BAR = {
    "Xp",
    "Azerite",
    "Honor",
    "Reputation"
}

local BAR_DB = BaikStatusBarMixin.DB_OPTION

local function GetOpts()
    return {
        name = "TrackingBar",
        type = "group",
        args = {
            vis = {
                name = "Enable",
                type = "multiselect",
                values = TRACKING_BAR,
                get = function(self, key)
                    return Database:Get(BAR_DB[key])
                end,
                set = function(self, key, value, ...)
                    Database:Set(BAR_DB[key], value)
                    BaikTrackingBar:SetupBars()
                end
            }
        }
    }
end

-- Ace3 Callbacks
function TrackingBar:OnInitialize()
    Log:v("TrackingBar_OnInitialize")
    Option:AddOption(BaikActionbar.OPTION_NAME, OPTION_NAME, GetOpts())
    for _, option in pairs(BAR_DB) do
        Database:InitIfEmpty(option, true)
    end
end

function TrackingBar:OnEnable()
    Log:v("TrackingBar_OnEnable")
end

function TrackingBar:OnDisable()
    Log:v("TrackingBar_OnDisable")
end
