BaikHonorBarMixin = CreateFromMixins(BaikStatusBarMixin)

function BaikHonorBarMixin:RegisterParent(parent)
    self:RegisterEvent("ZONE_CHANGED")
    self:RegisterEvent("ZONE_CHANGED_NEW_AREA")

    local function SetupBars()
        parent:SetupBars()
    end
    hooksecurefunc("SetWatchingHonorAsXP", SetupBars)
end

function BaikHonorBarMixin:ShouldBeVisible()
    return (IsWatchingHonorAsXP() or InActiveBattlefield() or IsInActiveWorldPVP()) and self:GetHonorOption()
end

function BaikHonorBarMixin:UpdateText()
    local current = UnitHonor("player")
    local maxHonor = UnitHonorMax("player")

    if ( not current or not maxHonor ) then
        return
    end

    self:SetBarText(HONOR_BAR:format(current, maxHonor))
end

function BaikHonorBarMixin:UpdateBar()
    local current = UnitHonor("player")
    local maxHonor = UnitHonorMax("player")
    local level = UnitHonorLevel("player")

    self:SetBarValues(current, 0, maxHonor, level)
    self:SetBarColor(1.0, 0.24, 0)
end

function BaikHonorBarMixin:Update()
    self:UpdateText()
    self:UpdateBar()
end

function BaikHonorBarMixin:OnShow()
    self:Update()
end

function BaikHonorBarMixin:OnEvent(event, ...)
    self:Update()
end

function BaikHonorBarMixin:OnLoad()
    self.priority = 2
    self:RegisterEvent("HONOR_XP_UPDATE")
    self.StatusBar:SetOnAnimatedValueChangedCallback(function() self:UpdateText() end)
    self.StatusBar.OnFinishedCallback = function(...)
        self.StatusBar:OnAnimFinished(...)
    end
    self:GetParent():AddBar(self)
end
