local BaikCore = LibStub("AceAddon-3.0"):GetAddon("BaikCore")
local Database = BaikCore.Database

BaikStatusBarMixin = {}

local DB_OPTION = {
    "action_tracking_xp",
    "action_tracking_azerite",
    "action_tracking_honor",
    "action_tracking_rep",
}
BaikStatusBarMixin.DB_OPTION = DB_OPTION

local XP_IDX = 1
local AZERITE_IDX = 2
local HONOR_IDX = 3
local REP_IDX = 4


local function GetDbValue(idx)
    return Database:Get(DB_OPTION[idx], true)
end

function BaikStatusBarMixin:GetXpOption()
    return GetDbValue(XP_IDX)
end

function BaikStatusBarMixin:GetAzeriteOption()
    return GetDbValue(AZERITE_IDX)
end

function BaikStatusBarMixin:GetHonorOption()
    return GetDbValue(HONOR_IDX)
end

function BaikStatusBarMixin:GetRepOption()
    return GetDbValue(REP_IDX)
end

function BaikStatusBarMixin:RegisterParent(parent)
    error(self:GetName(), "must implement RegisterParent")
end

function BaikStatusBarMixin:GetPriority()
    return self.priority
end

function BaikStatusBarMixin:ShouldBeVisible()
    error(self:GetName(), "must implement ShouldBeVisible")
end

function BaikStatusBarMixin:SetBarValues(curValue, minBar, maxBar, level)
    self.StatusBar:SetAnimatedValues(curValue, minBar, maxBar, level)
end

function BaikStatusBarMixin:SetBarColor(r, g, b)
    self.StatusBar:SetStatusBarColor(r, g, b)
    self.StatusBar:SetAnimatedTextureColors(r, g, b)
end

function BaikStatusBarMixin:SetBarText(barText)
    self.OverlayFrame.Text:SetText(barText)
end

